import{s as St,n as Vt,o as jt}from"../chunks/scheduler.6062bdaf.js";import{S as Gt,i as Xt,g as o,s as i,u as _,A as Jt,h as a,f as n,c as s,j as l,v as f,y as x,k as m,o as e,a as u,w as b,d as z,t as v,x as T}from"../chunks/index.7658fce3.js";import{D as U}from"../chunks/Docstring.5ab7be14.js";import{I as Wt}from"../chunks/IconCopyLink.d844a6a2.js";function Bt(wt){let p,tt,B,et,g,O,K,P,gt,A,Ct="Quantization",nt,h,y,Y,N,ht,H,Pt="ORTQuantizer",ot,r,D,_t,W,Nt="Handles the ONNX Runtime quantization process for models shared on huggingface.co/models.",ft,$,F,xt,S,Dt="Computes the quantization ranges.",bt,q,L,zt,V,Ft="Performs the calibration step and computes the quantization ranges.",vt,R,E,Tt,j,Lt="Instantiates a <code>ORTQuantizer</code> from a an ONNX model file or an <code>ORTModel</code>.",Ot,Q,k,yt,G,Et="Creates the calibration <code>datasets.Dataset</code> to use for the post-training static quantization calibration step.",$t,w,I,qt,X,kt="Performs the calibration step and collects the quantization ranges without computing them.",Rt,C,M,Qt,J,It="Quantizes a model given the optimization specifications defined in <code>quantization_config</code>.",at,Z,rt;return P=new Wt({}),N=new Wt({}),D=new U({props:{name:"class optimum.onnxruntime.ORTQuantizer",anchor:"optimum.onnxruntime.ORTQuantizer",parameters:[{name:"onnx_model_path",val:": Path"},{name:"config",val:": typing.Optional[ForwardRef('PretrainedConfig')] = None"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/quantization.py#L84"}}),F=new U({props:{name:"compute_ranges",anchor:"optimum.onnxruntime.ORTQuantizer.compute_ranges",parameters:[],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/quantization.py#L269",returnDescription:`
<p>The dictionary mapping the nodes name to their quantization ranges.</p>
`}}),L=new U({props:{name:"fit",anchor:"optimum.onnxruntime.ORTQuantizer.fit",parameters:[{name:"dataset",val:": Dataset"},{name:"calibration_config",val:": CalibrationConfig"},{name:"onnx_augmented_model_name",val:": typing.Union[str, pathlib.Path] = 'augmented_model.onnx'"},{name:"operators_to_quantize",val:": typing.Optional[typing.List[str]] = None"},{name:"batch_size",val:": int = 1"},{name:"use_external_data_format",val:": bool = False"},{name:"use_gpu",val:": bool = False"},{name:"force_symmetric_range",val:": bool = False"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTQuantizer.fit.dataset",description:`<strong>dataset</strong> (<code>Dataset</code>) &#x2014;
The dataset to use when performing the calibration step.`,name:"dataset"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.calibration_config",description:`<strong>calibration_config</strong> (<code>~CalibrationConfig</code>) &#x2014;
The configuration containing the parameters related to the calibration step.`,name:"calibration_config"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.onnx_augmented_model_name",description:`<strong>onnx_augmented_model_name</strong> (<code>Union[str, Path]</code>, defaults to <code>&quot;augmented_model.onnx&quot;</code>) &#x2014;
The path used to save the augmented model used to collect the quantization ranges.`,name:"onnx_augmented_model_name"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.operators_to_quantize",description:`<strong>operators_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
List of the operators types to quantize.`,name:"operators_to_quantize"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, defaults to 1) &#x2014;
The batch size to use when collecting the quantization ranges values.`,name:"batch_size"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.use_external_data_format",description:`<strong>use_external_data_format</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use external data format to store model which size is &gt;= 2Gb.`,name:"use_external_data_format"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.use_gpu",description:`<strong>use_gpu</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the GPU when collecting the quantization ranges values.`,name:"use_gpu"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.force_symmetric_range",description:`<strong>force_symmetric_range</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to make the quantization ranges symmetric.`,name:"force_symmetric_range"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/quantization.py#L165",returnDescription:`
<p>The dictionary mapping the nodes name to their quantization ranges.</p>
`}}),E=new U({props:{name:"from_pretrained",anchor:"optimum.onnxruntime.ORTQuantizer.from_pretrained",parameters:[{name:"model_or_path",val:": typing.Union[ForwardRef('ORTModel'), str, pathlib.Path]"},{name:"file_name",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTQuantizer.from_pretrained.model_or_path",description:`<strong>model_or_path</strong> (<code>Union[ORTModel, str, Path]</code>) &#x2014;
Can be either:<ul>
<li>A path to a saved exported ONNX Intermediate Representation (IR) model, e.g., \`./my_model_directory/.</li>
<li>Or an <code>ORTModelForXX</code> class, e.g., <code>ORTModelForQuestionAnswering</code>.</li>
</ul>`,name:"model_or_path"},{anchor:"optimum.onnxruntime.ORTQuantizer.from_pretrained.file_name(Optional[str],",description:`<strong>file_name(<code>Optional[str]</code>,</strong> defaults to <code>None</code>) &#x2014;
Overwrites the default model file name from <code>&quot;model.onnx&quot;</code> to <code>file_name</code>.
This allows you to load different model files from the same repository or directory.`,name:"file_name(Optional[str],"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/quantization.py#L111",returnDescription:`
<p>An instance of <code>ORTQuantizer</code>.</p>
`}}),k=new U({props:{name:"get_calibration_dataset",anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset",parameters:[{name:"dataset_name",val:": str"},{name:"num_samples",val:": int = 100"},{name:"dataset_config_name",val:": typing.Optional[str] = None"},{name:"dataset_split",val:": typing.Optional[str] = None"},{name:"preprocess_function",val:": typing.Optional[typing.Callable] = None"},{name:"preprocess_batch",val:": bool = True"},{name:"seed",val:": int = 2016"},{name:"use_auth_token",val:": bool = False"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.dataset_name",description:`<strong>dataset_name</strong> (<code>str</code>) &#x2014;
The dataset repository name on the Hugging Face Hub or path to a local directory containing data files
to load to use for the calibration step.`,name:"dataset_name"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.num_samples",description:`<strong>num_samples</strong> (<code>int</code>, defaults to 100) &#x2014;
The maximum number of samples composing the calibration dataset.`,name:"num_samples"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.dataset_config_name",description:`<strong>dataset_config_name</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
The name of the dataset configuration.`,name:"dataset_config_name"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.dataset_split",description:`<strong>dataset_split</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
Which split of the dataset to use to perform the calibration step.`,name:"dataset_split"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.preprocess_function",description:`<strong>preprocess_function</strong> (<code>Optional[Callable]</code>, defaults to <code>None</code>) &#x2014;
Processing function to apply to each example after loading dataset.`,name:"preprocess_function"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.preprocess_batch",description:`<strong>preprocess_batch</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether the <code>preprocess_function</code> should be batched.`,name:"preprocess_batch"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.seed",description:`<strong>seed</strong> (<code>int</code>, defaults to 2016) &#x2014;
The random seed to use when shuffling the calibration dataset.`,name:"seed"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.use_auth_token",description:`<strong>use_auth_token</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the token generated when running <code>transformers-cli login</code> (necessary for some datasets
like ImageNet).`,name:"use_auth_token"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/quantization.py#L443",returnDescription:`
<p>The calibration <code>datasets.Dataset</code> to use for the post-training static quantization calibration
step.</p>
`}}),I=new U({props:{name:"partial_fit",anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit",parameters:[{name:"dataset",val:": Dataset"},{name:"calibration_config",val:": CalibrationConfig"},{name:"onnx_augmented_model_name",val:": typing.Union[str, pathlib.Path] = 'augmented_model.onnx'"},{name:"operators_to_quantize",val:": typing.Optional[typing.List[str]] = None"},{name:"batch_size",val:": int = 1"},{name:"use_external_data_format",val:": bool = False"},{name:"use_gpu",val:": bool = False"},{name:"force_symmetric_range",val:": bool = False"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.dataset",description:`<strong>dataset</strong> (<code>Dataset</code>) &#x2014;
The dataset to use when performing the calibration step.`,name:"dataset"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.calibration_config",description:`<strong>calibration_config</strong> (<code>CalibrationConfig</code>) &#x2014;
The configuration containing the parameters related to the calibration step.`,name:"calibration_config"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.onnx_augmented_model_name",description:`<strong>onnx_augmented_model_name</strong> (<code>Union[str, Path]</code>, defaults to <code>&quot;augmented_model.onnx&quot;</code>) &#x2014;
The path used to save the augmented model used to collect the quantization ranges.`,name:"onnx_augmented_model_name"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.operators_to_quantize",description:`<strong>operators_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
List of the operators types to quantize.`,name:"operators_to_quantize"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, defaults to 1) &#x2014;
The batch size to use when collecting the quantization ranges values.`,name:"batch_size"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.use_external_data_format",description:`<strong>use_external_data_format</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether uto se external data format to store model which size is &gt;= 2Gb.`,name:"use_external_data_format"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.use_gpu",description:`<strong>use_gpu</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the GPU when collecting the quantization ranges values.`,name:"use_gpu"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.force_symmetric_range",description:`<strong>force_symmetric_range</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to make the quantization ranges symmetric.`,name:"force_symmetric_range"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/quantization.py#L219"}}),M=new U({props:{name:"quantize",anchor:"optimum.onnxruntime.ORTQuantizer.quantize",parameters:[{name:"quantization_config",val:": QuantizationConfig"},{name:"save_dir",val:": typing.Union[str, pathlib.Path]"},{name:"file_suffix",val:": typing.Optional[str] = 'quantized'"},{name:"calibration_tensors_range",val:": typing.Union[typing.Dict[str, typing.Tuple[float, float]], NoneType] = None"},{name:"use_external_data_format",val:": bool = False"},{name:"preprocessor",val:": typing.Optional[optimum.onnxruntime.preprocessors.quantization.QuantizationPreprocessor] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTQuantizer.quantize.quantization_config",description:`<strong>quantization_config</strong> (<code>QuantizationConfig</code>) &#x2014;
The configuration containing the parameters related to quantization.`,name:"quantization_config"},{anchor:"optimum.onnxruntime.ORTQuantizer.quantize.save_dir",description:`<strong>save_dir</strong> (<code>Union[str, Path]</code>) &#x2014;
The directory where the quantized model should be saved.`,name:"save_dir"},{anchor:"optimum.onnxruntime.ORTQuantizer.quantize.file_suffix",description:`<strong>file_suffix</strong> (<code>Optional[str]</code>, defaults to <code>&quot;quantized&quot;</code>) &#x2014;
The file_suffix used to save the quantized model.`,name:"file_suffix"},{anchor:"optimum.onnxruntime.ORTQuantizer.quantize.calibration_tensors_range",description:`<strong>calibration_tensors_range</strong> (<code>Optional[Dict[str, Tuple[float, float]]]</code>, defaults to <code>None</code>) &#x2014;
The dictionary mapping the nodes name to their quantization ranges, used and required only when applying static quantization.`,name:"calibration_tensors_range"},{anchor:"optimum.onnxruntime.ORTQuantizer.quantize.use_external_data_format",description:`<strong>use_external_data_format</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use external data format to store model which size is &gt;= 2Gb.`,name:"use_external_data_format"},{anchor:"optimum.onnxruntime.ORTQuantizer.quantize.preprocessor",description:`<strong>preprocessor</strong> (<code>Optional[QuantizationPreprocessor]</code>, defaults to <code>None</code>) &#x2014;
The preprocessor to use to collect the nodes to include or exclude from quantization.`,name:"preprocessor"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/quantization.py#L288",returnDescription:`
<p>The path of the resulting quantized model.</p>
`}}),{c(){p=o("meta"),tt=i(),B=o("p"),et=i(),g=o("h1"),O=o("a"),K=o("span"),_(P.$$.fragment),gt=i(),A=o("span"),A.textContent=Ct,nt=i(),h=o("h2"),y=o("a"),Y=o("span"),_(N.$$.fragment),ht=i(),H=o("span"),H.textContent=Pt,ot=i(),r=o("div"),_(D.$$.fragment),_t=i(),W=o("p"),W.textContent=Nt,ft=i(),$=o("div"),_(F.$$.fragment),xt=i(),S=o("p"),S.textContent=Dt,bt=i(),q=o("div"),_(L.$$.fragment),zt=i(),V=o("p"),V.textContent=Ft,vt=i(),R=o("div"),_(E.$$.fragment),Tt=i(),j=o("p"),j.innerHTML=Lt,Ot=i(),Q=o("div"),_(k.$$.fragment),yt=i(),G=o("p"),G.innerHTML=Et,$t=i(),w=o("div"),_(I.$$.fragment),qt=i(),X=o("p"),X.textContent=kt,Rt=i(),C=o("div"),_(M.$$.fragment),Qt=i(),J=o("p"),J.innerHTML=It,at=i(),Z=o("p"),this.h()},l(t){const d=Jt("svelte-1phssyn",document.head);p=a(d,"META",{name:!0,content:!0}),d.forEach(n),tt=s(t),B=a(t,"P",{}),l(B).forEach(n),et=s(t),g=a(t,"H1",{class:!0});var it=l(g);O=a(it,"A",{id:!0,class:!0,href:!0});var Mt=l(O);K=a(Mt,"SPAN",{});var Ut=l(K);f(P.$$.fragment,Ut),Ut.forEach(n),Mt.forEach(n),gt=s(it),A=a(it,"SPAN",{"data-svelte-h":!0}),x(A)!=="svelte-9x6jxy"&&(A.textContent=Ct),it.forEach(n),nt=s(t),h=a(t,"H2",{class:!0});var st=l(h);y=a(st,"A",{id:!0,class:!0,href:!0});var At=l(y);Y=a(At,"SPAN",{});var Ht=l(Y);f(N.$$.fragment,Ht),Ht.forEach(n),At.forEach(n),ht=s(st),H=a(st,"SPAN",{"data-svelte-h":!0}),x(H)!=="svelte-1fu9i8j"&&(H.textContent=Pt),st.forEach(n),ot=s(t),r=a(t,"DIV",{class:!0});var c=l(r);f(D.$$.fragment,c),_t=s(c),W=a(c,"P",{"data-svelte-h":!0}),x(W)!=="svelte-1tiz3jr"&&(W.textContent=Nt),ft=s(c),$=a(c,"DIV",{class:!0});var mt=l($);f(F.$$.fragment,mt),xt=s(mt),S=a(mt,"P",{"data-svelte-h":!0}),x(S)!=="svelte-1183xvy"&&(S.textContent=Dt),mt.forEach(n),bt=s(c),q=a(c,"DIV",{class:!0});var ct=l(q);f(L.$$.fragment,ct),zt=s(ct),V=a(ct,"P",{"data-svelte-h":!0}),x(V)!=="svelte-1tzjvze"&&(V.textContent=Ft),ct.forEach(n),vt=s(c),R=a(c,"DIV",{class:!0});var lt=l(R);f(E.$$.fragment,lt),Tt=s(lt),j=a(lt,"P",{"data-svelte-h":!0}),x(j)!=="svelte-18q5clc"&&(j.innerHTML=Lt),lt.forEach(n),Ot=s(c),Q=a(c,"DIV",{class:!0});var dt=l(Q);f(k.$$.fragment,dt),yt=s(dt),G=a(dt,"P",{"data-svelte-h":!0}),x(G)!=="svelte-1xfi4es"&&(G.innerHTML=Et),dt.forEach(n),$t=s(c),w=a(c,"DIV",{class:!0});var ut=l(w);f(I.$$.fragment,ut),qt=s(ut),X=a(ut,"P",{"data-svelte-h":!0}),x(X)!=="svelte-g6p4yh"&&(X.textContent=kt),ut.forEach(n),Rt=s(c),C=a(c,"DIV",{class:!0});var pt=l(C);f(M.$$.fragment,pt),Qt=s(pt),J=a(pt,"P",{"data-svelte-h":!0}),x(J)!=="svelte-4dslow"&&(J.innerHTML=It),pt.forEach(n),c.forEach(n),at=s(t),Z=a(t,"P",{}),l(Z).forEach(n),this.h()},h(){m(p,"name","hf:doc:metadata"),m(p,"content",JSON.stringify(Kt)),m(O,"id","quantization"),m(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(O,"href","#quantization"),m(g,"class","relative group"),m(y,"id","optimum.onnxruntime.ORTQuantizer"),m(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(y,"href","#optimum.onnxruntime.ORTQuantizer"),m(h,"class","relative group"),m($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(r,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,d){e(document.head,p),u(t,tt,d),u(t,B,d),u(t,et,d),u(t,g,d),e(g,O),e(O,K),b(P,K,null),e(g,gt),e(g,A),u(t,nt,d),u(t,h,d),e(h,y),e(y,Y),b(N,Y,null),e(h,ht),e(h,H),u(t,ot,d),u(t,r,d),b(D,r,null),e(r,_t),e(r,W),e(r,ft),e(r,$),b(F,$,null),e($,xt),e($,S),e(r,bt),e(r,q),b(L,q,null),e(q,zt),e(q,V),e(r,vt),e(r,R),b(E,R,null),e(R,Tt),e(R,j),e(r,Ot),e(r,Q),b(k,Q,null),e(Q,yt),e(Q,G),e(r,$t),e(r,w),b(I,w,null),e(w,qt),e(w,X),e(r,Rt),e(r,C),b(M,C,null),e(C,Qt),e(C,J),u(t,at,d),u(t,Z,d),rt=!0},p:Vt,i(t){rt||(z(P.$$.fragment,t),z(N.$$.fragment,t),z(D.$$.fragment,t),z(F.$$.fragment,t),z(L.$$.fragment,t),z(E.$$.fragment,t),z(k.$$.fragment,t),z(I.$$.fragment,t),z(M.$$.fragment,t),rt=!0)},o(t){v(P.$$.fragment,t),v(N.$$.fragment,t),v(D.$$.fragment,t),v(F.$$.fragment,t),v(L.$$.fragment,t),v(E.$$.fragment,t),v(k.$$.fragment,t),v(I.$$.fragment,t),v(M.$$.fragment,t),rt=!1},d(t){t&&(n(tt),n(B),n(et),n(g),n(nt),n(h),n(ot),n(r),n(at),n(Z)),n(p),T(P),T(N),T(D),T(F),T(L),T(E),T(k),T(I),T(M)}}}const Kt={local:"quantization",sections:[{local:"optimum.onnxruntime.ORTQuantizer",title:"ORTQuantizer"}],title:"Quantization"};function Yt(wt){return jt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class oe extends Gt{constructor(p){super(),Xt(this,p,Yt,Bt,St,{})}}export{oe as component};
