import{s as ro,o as po,n as so}from"../chunks/scheduler.6062bdaf.js";import{S as ho,i as co,g as a,s as l,u as d,A as uo,h as o,f as t,c as s,j as c,v as f,y as p,k as r,o as h,a as i,w as m,d as v,t as g,x as w}from"../chunks/index.7658fce3.js";import{T as lo}from"../chunks/Tip.616c3b1d.js";import{I as y}from"../chunks/IconCopyLink.d844a6a2.js";import{C as Mt}from"../chunks/CodeBlock.83a83418.js";function fo(ht){let u,x=`Usually <code>round(a/S + Z)</code> corresponds to the smallest representable value in the considered data type, and <code>round(b/S + Z)</code>
to the biggest one. But this can vary, for instance when using a <em>symmetric quantization scheme</em> as you will see in the next
paragraph.`;return{c(){u=a("p"),u.innerHTML=x},l(b){u=o(b,"P",{"data-svelte-h":!0}),p(u)!=="svelte-d33l1n"&&(u.innerHTML=x)},m(b,E){i(b,u,E)},p:so,d(b){b&&t(u)}}}function mo(ht){let u,x=`The section is not fundamental to understand the rest. It explains in brief how numbers are represented in computers.
Since quantization is about going from one representation to another, it can be useful to have some basics, but it is
definitely not mandatory.`;return{c(){u=a("p"),u.textContent=x},l(b){u=o(b,"P",{"data-svelte-h":!0}),p(u)!=="svelte-193nbxk"&&(u.textContent=x)},m(b,E){i(b,u,E)},p:so,d(b){b&&t(u)}}}function vo(ht){let u,x,b,E,$,N,Ct,te,mi,ct,zi="Quantization",Bt,ne,Hi=`Quantization is a technique to reduce the computational and memory costs of running inference by representing the
weights and activations with low-precision data types like 8-bit integer (<code>int8</code>) instead of the usual 32-bit floating
point (<code>float32</code>).`,Ft,ie,Li=`Reducing the number of bits means the resulting model requires less memory storage, consumes less energy (in theory), and
operations like matrix multiplication can be performed much faster with integer arithmetic. It also allows to run models
on embedded devices, which sometimes only support integer data types.`,Ot,T,U,qt,ae,vi,ut,ji="Theory",Rt,oe,Pi=`The basic idea behind quantization is quite easy: going from high-precision representation (usually the regular 32-bit
floating-point) for weights and activations to a lower precision data type. The most common lower precision data types
are:`,Zt,le,Ai="<li><code>float16</code>, accumulation data type <code>float16</code></li> <li><code>bfloat16</code>, accumulation data type <code>float32</code></li> <li><code>int16</code>, accumulation data type <code>int32</code></li> <li><code>int8</code>, accumulation data type <code>int32</code></li>",Wt,se,Si=`The accumulation data type specifies the type of the result of accumulating (adding, multiplying, etc) values of the
data type in question. For example, let’s consider two <code>int8</code> values <code>A = 127</code>, <code>B = 127</code>, and let’s define <code>C</code> as the
sum of <code>A</code> and <code>B</code>:`,Dt,re,Gt,pe,Ei=`Here the result is much bigger than the biggest representable value in <code>int8</code>, which is <code>127</code>. Hence the need for a larger
precision data type to avoid a huge precision loss that would make the whole quantization process useless.`,Kt,_,I,kt,he,gi,dt,Ni="Quantization",Vt,ce,Ui="The two most common quantization cases are <code>float32 -&gt; float16</code> and <code>float32 -&gt; int8</code>.",Xt,M,J,zt,ue,wi,ft,Ii="Quantization to <code>float16</code>",Yt,de,Ji=`Performing quantization to go from <code>float32</code> to <code>float16</code> is quite straightforward since both data types follow the same
representation scheme. The questions to ask yourself when quantizing an operation to <code>float16</code> are:`,en,fe,Qi=`<li>Does my operation have a <code>float16</code> implementation?</li> <li>Does my hardware suport <code>float16</code>? For instance, Intel CPUs <a href="https://scicomp.stackexchange.com/a/35193" rel="nofollow">have been supporting <code>float16</code> as a storage type, but
computation is done after converting to <code>float32</code></a>. Full support will come
in Cooper Lake and Sapphire Rapids.</li> <li>Is my operation sensitive to lower precision?
For instance the value of epsilon in <code>LayerNorm</code> is usually very small (~ <code>1e-12</code>), but the smallest representable value in
<code>float16</code> is ~ <code>6e-5</code>, this can cause <code>NaN</code> issues.  The same applies for big values.</li>`,tn,C,Q,Ht,me,bi,mt,Bi="Quantization to <code>int8</code>",nn,ve,Fi=`Performing quantization to go from <code>float32</code> to <code>int8</code> is more tricky. Only 256 values can be represented in <code>int8</code>,
while <code>float32</code> can represent a very wide range of values. The idea is to find the best way to project our range <code>[a, b]</code>
of <code>float32</code> values  to the <code>int8</code> space.`,an,ge,Oi=`Let’s consider a float <code>x</code> in <code>[a, b]</code>, then we can write the following quantization scheme, also called the <em>affine
quantization scheme</em>:`,on,we,ln,be,Ri="where:",sn,ye,Zi=`<li><code>x_q</code> is the quantized <code>int8</code> value associated to <code>x</code></li> <li><code>S</code> and <code>Z</code> are the quantization parameters<ul><li><code>S</code> is the scale, and is a positive <code>float32</code></li> <li><code>Z</code> is called the zero-point, it is the <code>int8</code> value corresponding to the value <code>0</code> in the <code>float32</code> realm. This is
important to be able to represent exactly the value <code>0</code> because it is used everywhere throughout machine learning
models.</li></ul></li>`,rn,xe,Wi="The quantized value <code>x_q</code> of <code>x</code> in <code>[a, b]</code> can be computed as follows:",pn,$e,hn,Te,Di=`And <code>float32</code> values outside of the <code>[a, b]</code> range are clipped to the closest representable value, so for any
floating-point number <code>x</code>:`,cn,_e,un,B,dn,q,F,Lt,Me,yi,vt,Gi="Symmetric and affine quantization schemes",fn,Ce,Ki="The equation above is called the <em>affine quantization sheme</em> because the mapping from <code>[a, b]</code> to <code>int8</code> is an affine one.",mn,qe,Vi=`A common special case of this scheme is the <em>symmetric quantization scheme</em>, where we consider a symmetric range of float values <code>[-a, a]</code>.
In this case the integer space is usally <code>[-127, 127]</code>, meaning that the <code>-128</code> is opted out of the regular <code>[-128, 127]</code> signed <code>int8</code> range.
The reason being that having both ranges symmetric allows to have <code>Z = 0</code>. While one value out of the 256 representable
values is lost, it can provide a speedup since a lot of addition operations can be skipped.`,vn,ke,Xi=`<strong>Note</strong>: To learn how the quantization parameters <code>S</code> and <code>Z</code> are computed, you can read the
<a href="https://arxiv.org/abs/1712.05877" rel="nofollow">Quantization and Training of Neural Networks for Efficient Integer-Arithmetic-Only Inference</a>
paper, or <a href="https://leimao.github.io/article/Neural-Networks-Quantization" rel="nofollow">Lei Mao’s blog post</a> on the subject.`,gn,k,O,jt,ze,xi,gt,Yi="Per-tensor and per-channel quantization",wn,He,ea="Depending on the accuracy / latency trade-off you are targetting you can play with the granularity of the quantization parameters:",bn,Le,ta=`<li>Quantization parameters can be computed on a <em>per-tensor</em> basis, meaning that one pair of <code>(S, Z)</code> will be used per
tensor.</li> <li>Quantization parameters can be computed on a <em>per-channel</em> basis, meaning that it is possible to store a pair of
<code>(S, Z)</code> per element along one of the dimensions of a tensor. For example for a tensor of shape <code>[N, C, H, W]</code>, having
<em>per-channel</em> quantization parameters for the second dimension would result in having <code>C</code> pairs of <code>(S, Z)</code>. While this
can give a better accuracy, it requires more memory.</li>`,yn,z,R,Pt,je,$i,wt,na="Calibration",xn,Pe,ia=`The section above described how quantization from <code>float32</code> to <code>int8</code> works, but one question
remains: how is the <code>[a, b]</code> range of <code>float32</code> values determined? That is where calibration comes in to play.`,$n,Ae,aa=`Calibration is the step during quantization where the <code>float32</code> ranges are computed. For weights it is quite easy since
the actual range is known at <em>quantization-time</em>. But it is less clear for activations, and different approaches exist:`,Tn,Se,oa=`<li>Post training <strong>dynamic quantization</strong>: the range for each activation is computed on the fly at <em>runtime</em>. While this
gives great results without too much work, it can be a bit slower than static quantization because of the overhead
introduced by computing the range each time.
It is also not an option on certain hardware.</li> <li>Post training <strong>static quantization</strong>: the range for each activation is computed in advance at <em>quantization-time</em>,
typically by passing representative data through the model and recording the activation values. In practice, the steps are:<ol><li>Observers are put on activations to record their values.</li> <li>A certain number of forward passes on a calibration dataset is done (around <code>200</code> examples is enough).</li> <li>The ranges for each computation are computed according to some <em>calibration technique</em>.</li></ol></li> <li><strong>Quantization aware training</strong>: the range for each activation is computed at <em>training-time</em>, following the same idea
than post training static quantization. But “fake quantize” operators are used instead of observers: they record
values just as observers do, but they also simulate the error induced by quantization to let the model adapt to it.</li>`,_n,Ee,la=`For both post training static quantization and quantization aware training, it is necessary to define calibration
techniques, the most common are:`,Mn,Ne,sa=`<li>Min-max: the computed range is <code>[min observed value, max observed value]</code>, this works well with weights.</li> <li>Moving average min-max: the computed range is <code>[moving average min observed value, moving average max observed value]</code>,
this works well with activations.</li> <li>Histogram: records a histogram of values along with min and max values, then chooses according to some criterion:<ul><li>Entropy: the range is computed as the one minimizing the error between the full-precision and the quantized data.</li> <li>Mean Square Error: the range is computed as the one minimizing the mean square error between the full-precision and
the quantized data.</li> <li>Percentile: the range is computed using a given percentile value <code>p</code> on the observed values. The idea is to try to have
<code>p%</code> of the observed values in the computed range. While this is possible when doing affine quantization, it is not always
possible to exactly match that when doing symmetric quantization. You can check <a href="https://github.com/microsoft/onnxruntime/blob/2cb12caf9317f1ded37f6db125cb03ba99320c40/onnxruntime/python/tools/quantization/calibrate.py#L698" rel="nofollow">how it is done in ONNX
Runtime</a>
for more details.</li></ul></li>`,Cn,H,Z,At,Ue,Ti,bt,ra="Pratical steps to follow to quantize a model to <code>int8</code>",qn,Ie,pa="To effectively quantize a model to <code>int8</code>, the steps to follow are:",kn,Je,ha=`<li>Choose which operators to quantize. Good operators to quantize are the one dominating it terms of computation time,
for instance linear projections and matrix multiplications.</li> <li>Try post-training dynamic quantization, if it is fast enough stop here, otherwise continue to step 3.</li> <li>Try post-training static quantization which can be faster than dynamic quantization but often with a drop in terms of
accuracy. Apply observers to your models in places where you want to quantize.</li> <li>Choose a calibration technique and perform it.</li> <li>Convert the model to its quantized form: the observers are removed and the <code>float32</code> operators are converted to their <code>int8</code>
coutnerparts.</li> <li>Evaluate the quantized model: is the accuracy good enough? If yes, stop here, otherwise start again at step 3 but
with quantization aware training this time.</li>`,zn,L,W,St,Qe,_i,yt,ca="Supported tools to perform quantization in 🤗 Optimum",Hn,Be,ua="🤗 Optimum provides APIs to perform quantization using different tools for different targets:",Ln,Fe,da=`<li>The <code>optimum.onnxruntime</code> package allows to
<a href="https://huggingface.co/docs/optimum/onnxruntime/usage_guides/quantization" rel="nofollow">quantize and run ONNX models</a> using the
ONNX Runtime tool.</li> <li>The <code>optimum.intel</code> package enables to <a href="https://huggingface.co/docs/optimum/intel/optimization_inc" rel="nofollow">quantize</a> 🤗 Transformers
models while respecting accuracy and latency constraints.</li> <li>The <code>optimum.fx</code> package provides wrappers around the
<a href="https://pytorch.org/docs/stable/quantization-support.html#torch-quantization-quantize-fx" rel="nofollow">PyTorch quantization functions</a>
to allow graph-mode quantization of 🤗 Transformers models in PyTorch. This is a lower-level API compared to the two
mentioned above, giving more flexibility, but requiring more work on your end.</li> <li>The <code>optimum.gptq</code> package allows to <a href="../llm_quantization/usage_guides/quantization">quantize and run LLM models</a> with GPTQ.</li>`,jn,j,D,Et,Oe,Mi,xt,fa="Going further: How do machines represent numbers?",Pn,G,An,Re,ma=`The most fundamental unit of representation for computers is the bit. Everything in computers is represented as a
sequence of bits, including numbers. But the representation varies whether the numbers in question are integers or
real numbers.`,Sn,P,K,Nt,Ze,Ci,$t,va="Integer representation",En,We,ga=`Integers are usually represented with the following bit lengths: <code>8</code>, <code>16</code>, <code>32</code>, <code>64</code>. When representing integers, two cases
are considered:`,Nn,De,wa=`<li>Unsigned (positive) integers: they are simply represented as a sequence of bits. Each bit corresponds to a power
of two (from <code>0</code> to <code>n-1</code> where <code>n</code> is the bit-length), and the resulting number is the sum of those powers of two.</li>`,Un,Ge,ba="Example: <code>19</code> is represented as an unsigned int8 as <code>00010011</code> because :",In,Ke,Jn,V,ya=`<li>Signed integers: it is less straightforward to represent signed integers, and multiple approachs exist, the most
common being the <em>two’s complement</em>. For more information, you can check the
<a href="https://en.wikipedia.org/wiki/Signed_number_representations" rel="nofollow">Wikipedia page</a> on the subject.</li>`,Qn,A,X,Ut,Ve,qi,Tt,xa="Real numbers representation",Bn,Xe,$a=`Real numbers are usually represented with the following bit lengths: <code>16</code>, <code>32</code>, <code>64</code>.
The two main ways of representing real numbers are:`,Fn,Ye,Ta="<li>Fixed-point: there are fixed number of digits reserved for representing the integer part and the fractional part.</li> <li>Floating-point: the number of digits for representing the integer and the fractional parts can vary.</li>",On,et,_a=`The floating-point representation can represent bigger ranges of values, and this is the one we will be focusing on
since it is the most commonly used. There are three components in the floating-point representation:`,Rn,tt,Ma="<li>The sign bit: this is the bit specifying the sign of the number.</li> <li>The exponent part</li>",Zn,nt,Ca="<li>5 bits in <code>float16</code></li> <li>8 bits in <code>bfloat16</code></li> <li>8 bits in <code>float32</code></li> <li>11 bits in <code>float64</code></li>",Wn,Y,qa="<li>The mantissa</li>",Dn,it,ka="<li>11 bits in <code>float16</code> (10 explictly stored)</li> <li>8 bits in <code>bfloat16</code> (7 explicitly stored)</li> <li>24 bits in <code>float32</code> (23 explictly stored)</li> <li>53 bits in <code>float64</code> (52 explictly stored)</li>",Gn,at,za=`For more information on the bits allocation for each data type, check the nice illustration on the Wikipedia page about
the <a href="https://en.wikipedia.org/wiki/Bfloat16_floating-point_format" rel="nofollow">bfloat16 floating-point format</a>.`,Kn,ot,Ha="For a real number <code>x</code> we have:",Vn,lt,Xn,S,ee,It,st,ki,_t,La="References",Yn,rt,ja=`<li>The
<a href="https://arxiv.org/abs/1712.05877" rel="nofollow">Quantization and Training of Neural Networks for Efficient Integer-Arithmetic-Only Inference</a> paper</li> <li>The <a href="https://iq.opengenus.org/basics-of-quantization-in-ml/" rel="nofollow">Basics of Quantization in Machine Learning (ML) for Beginners</a>
blog post</li> <li>The <a href="https://tivadardanka.com/blog/neural-networks-quantization" rel="nofollow">How to accelerate and compress neural networks with quantization</a>
blog post</li> <li>The Wikipedia pages on integers representation <a href="https://en.wikipedia.org/wiki/Integer_(computer_science)" rel="nofollow">here</a> and
<a href="https://en.wikipedia.org/wiki/Signed_number_representations" rel="nofollow">here</a></li> <li>The Wikipedia pages on<ul><li><a href="https://en.wikipedia.org/wiki/Bfloat16_floating-point_format" rel="nofollow">bfloat16 floating-point format</a></li> <li><a href="https://en.wikipedia.org/wiki/Half-precision_floating-point_format" rel="nofollow">Half-precision floating-point format</a></li> <li><a href="https://en.wikipedia.org/wiki/Single-precision_floating-point_format" rel="nofollow">Single-precision floating-point format</a></li> <li><a href="https://en.wikipedia.org/wiki/Double-precision_floating-point_format" rel="nofollow">Double-precision floating-point format</a></li></ul></li>`,ei,Jt,ti;return te=new y({}),ae=new y({}),re=new Mt({props:{code:"QyUyMCUzRCUyMEElMjAlMkIlMjBC",highlighted:'<span class="hljs-attr">C</span> = A + B',wrap:!1}}),he=new y({}),ue=new y({}),me=new y({}),we=new Mt({props:{code:"eCUyMCUzRCUyMFMlMjAqJTIwKHhfcSUyMC0lMjBaKQ==",highlighted:'<span class="hljs-attribute">x</span> <span class="hljs-operator">=</span> S * (x_q - Z)',wrap:!1}}),$e=new Mt({props:{code:"eF9xJTIwJTNEJTIwcm91bmQoeCUyRlMlMjAlMkIlMjBaKQ==",highlighted:'<span class="hljs-variable">x_q</span> = <span class="hljs-function"><span class="hljs-title"><span class="hljs-built_in">round</span></span>(<span class="hljs-variable">x</span>/<span class="hljs-variable">S</span> + <span class="hljs-variable">Z</span>)</span>',wrap:!1}}),_e=new Mt({props:{code:"eF9xJTIwJTNEJTIwY2xpcChyb3VuZCh4JTJGUyUyMCUyQiUyMFopJTJDJTIwcm91bmQoYSUyRlMlMjAlMkIlMjBaKSUyQyUyMHJvdW5kKGIlMkZTJTIwJTJCJTIwWikpJTBB",highlighted:`x_q = <span class="hljs-built_in">clip</span>(<span class="hljs-built_in">round</span>(x/S + Z), <span class="hljs-built_in">round</span>(a/S + Z), <span class="hljs-built_in">round</span>(b/S + Z))
`,wrap:!1}}),B=new lo({props:{$$slots:{default:[fo]},$$scope:{ctx:ht}}}),Me=new y({}),ze=new y({}),je=new y({}),Ue=new y({}),Qe=new y({}),Oe=new y({}),G=new lo({props:{$$slots:{default:[mo]},$$scope:{ctx:ht}}}),Ze=new y({}),Ke=new Mt({props:{code:"MTklMjAlM0QlMjAwJTIweCUyMDIlNUU3JTIwJTJCJTIwMCUyMHglMjAyJTVFNiUyMCUyQiUyMDAlMjB4JTIwMiU1RTUlMjAlMkIlMjAxJTIweCUyMDIlNUU0JTIwJTJCJTIwMCUyMHglMjAyJTVFMyUyMCUyQiUyMDAlMjB4JTIwMiU1RTIlMjAlMkIlMjAxJTIweCUyMDIlNUUxJTIwJTJCJTIwMSUyMHglMjAyJTVFMA==",highlighted:'<span class="hljs-attribute">19</span> = <span class="hljs-number">0</span> x <span class="hljs-number">2</span>^<span class="hljs-number">7</span> + <span class="hljs-number">0</span> x <span class="hljs-number">2</span>^<span class="hljs-number">6</span> + <span class="hljs-number">0</span> x <span class="hljs-number">2</span>^<span class="hljs-number">5</span> + <span class="hljs-number">1</span> x <span class="hljs-number">2</span>^<span class="hljs-number">4</span> + <span class="hljs-number">0</span> x <span class="hljs-number">2</span>^<span class="hljs-number">3</span> + <span class="hljs-number">0</span> x <span class="hljs-number">2</span>^<span class="hljs-number">2</span> + <span class="hljs-number">1</span> x <span class="hljs-number">2</span>^<span class="hljs-number">1</span> + <span class="hljs-number">1</span> x <span class="hljs-number">2</span>^<span class="hljs-number">0</span>',wrap:!1}}),Ve=new y({}),lt=new Mt({props:{code:"eCUyMCUzRCUyMHNpZ24lMjB4JTIwbWFudGlzc2ElMjB4JTIwKDIlNUVleHBvbmVudCk=",highlighted:'<span class="hljs-keyword">x</span> <span class="hljs-operator">=</span> sign <span class="hljs-keyword">x</span> mantissa <span class="hljs-keyword">x</span> (<span class="hljs-number">2</span>^exponent)',wrap:!1}}),st=new y({}),{c(){u=a("meta"),x=l(),b=a("p"),E=l(),$=a("h1"),N=a("a"),Ct=a("span"),d(te.$$.fragment),mi=l(),ct=a("span"),ct.textContent=zi,Bt=l(),ne=a("p"),ne.innerHTML=Hi,Ft=l(),ie=a("p"),ie.textContent=Li,Ot=l(),T=a("h2"),U=a("a"),qt=a("span"),d(ae.$$.fragment),vi=l(),ut=a("span"),ut.textContent=ji,Rt=l(),oe=a("p"),oe.textContent=Pi,Zt=l(),le=a("ul"),le.innerHTML=Ai,Wt=l(),se=a("p"),se.innerHTML=Si,Dt=l(),d(re.$$.fragment),Gt=l(),pe=a("p"),pe.innerHTML=Ei,Kt=l(),_=a("h2"),I=a("a"),kt=a("span"),d(he.$$.fragment),gi=l(),dt=a("span"),dt.textContent=Ni,Vt=l(),ce=a("p"),ce.innerHTML=Ui,Xt=l(),M=a("h3"),J=a("a"),zt=a("span"),d(ue.$$.fragment),wi=l(),ft=a("span"),ft.innerHTML=Ii,Yt=l(),de=a("p"),de.innerHTML=Ji,en=l(),fe=a("ul"),fe.innerHTML=Qi,tn=l(),C=a("h3"),Q=a("a"),Ht=a("span"),d(me.$$.fragment),bi=l(),mt=a("span"),mt.innerHTML=Bi,nn=l(),ve=a("p"),ve.innerHTML=Fi,an=l(),ge=a("p"),ge.innerHTML=Oi,on=l(),d(we.$$.fragment),ln=l(),be=a("p"),be.textContent=Ri,sn=l(),ye=a("ul"),ye.innerHTML=Zi,rn=l(),xe=a("p"),xe.innerHTML=Wi,pn=l(),d($e.$$.fragment),hn=l(),Te=a("p"),Te.innerHTML=Di,cn=l(),d(_e.$$.fragment),un=l(),d(B.$$.fragment),dn=l(),q=a("h3"),F=a("a"),Lt=a("span"),d(Me.$$.fragment),yi=l(),vt=a("span"),vt.textContent=Gi,fn=l(),Ce=a("p"),Ce.innerHTML=Ki,mn=l(),qe=a("p"),qe.innerHTML=Vi,vn=l(),ke=a("p"),ke.innerHTML=Xi,gn=l(),k=a("h3"),O=a("a"),jt=a("span"),d(ze.$$.fragment),xi=l(),gt=a("span"),gt.textContent=Yi,wn=l(),He=a("p"),He.textContent=ea,bn=l(),Le=a("ul"),Le.innerHTML=ta,yn=l(),z=a("h3"),R=a("a"),Pt=a("span"),d(je.$$.fragment),$i=l(),wt=a("span"),wt.textContent=na,xn=l(),Pe=a("p"),Pe.innerHTML=ia,$n=l(),Ae=a("p"),Ae.innerHTML=aa,Tn=l(),Se=a("ol"),Se.innerHTML=oa,_n=l(),Ee=a("p"),Ee.textContent=la,Mn=l(),Ne=a("ul"),Ne.innerHTML=sa,Cn=l(),H=a("h3"),Z=a("a"),At=a("span"),d(Ue.$$.fragment),Ti=l(),bt=a("span"),bt.innerHTML=ra,qn=l(),Ie=a("p"),Ie.innerHTML=pa,kn=l(),Je=a("ol"),Je.innerHTML=ha,zn=l(),L=a("h2"),W=a("a"),St=a("span"),d(Qe.$$.fragment),_i=l(),yt=a("span"),yt.textContent=ca,Hn=l(),Be=a("p"),Be.textContent=ua,Ln=l(),Fe=a("ul"),Fe.innerHTML=da,jn=l(),j=a("h2"),D=a("a"),Et=a("span"),d(Oe.$$.fragment),Mi=l(),xt=a("span"),xt.textContent=fa,Pn=l(),d(G.$$.fragment),An=l(),Re=a("p"),Re.textContent=ma,Sn=l(),P=a("h4"),K=a("a"),Nt=a("span"),d(Ze.$$.fragment),Ci=l(),$t=a("span"),$t.textContent=va,En=l(),We=a("p"),We.innerHTML=ga,Nn=l(),De=a("ol"),De.innerHTML=wa,Un=l(),Ge=a("p"),Ge.innerHTML=ba,In=l(),d(Ke.$$.fragment),Jn=l(),V=a("ol"),V.innerHTML=ya,Qn=l(),A=a("h4"),X=a("a"),Ut=a("span"),d(Ve.$$.fragment),qi=l(),Tt=a("span"),Tt.textContent=xa,Bn=l(),Xe=a("p"),Xe.innerHTML=$a,Fn=l(),Ye=a("ol"),Ye.innerHTML=Ta,On=l(),et=a("p"),et.textContent=_a,Rn=l(),tt=a("ol"),tt.innerHTML=Ma,Zn=l(),nt=a("ul"),nt.innerHTML=Ca,Wn=l(),Y=a("ol"),Y.innerHTML=qa,Dn=l(),it=a("ul"),it.innerHTML=ka,Gn=l(),at=a("p"),at.innerHTML=za,Kn=l(),ot=a("p"),ot.innerHTML=Ha,Vn=l(),d(lt.$$.fragment),Xn=l(),S=a("h2"),ee=a("a"),It=a("span"),d(st.$$.fragment),ki=l(),_t=a("span"),_t.textContent=La,Yn=l(),rt=a("ul"),rt.innerHTML=ja,ei=l(),Jt=a("p"),this.h()},l(e){const n=uo("svelte-1phssyn",document.head);u=o(n,"META",{name:!0,content:!0}),n.forEach(t),x=s(e),b=o(e,"P",{}),c(b).forEach(t),E=s(e),$=o(e,"H1",{class:!0});var pt=c($);N=o(pt,"A",{id:!0,class:!0,href:!0});var Qt=c(N);Ct=o(Qt,"SPAN",{});var Pa=c(Ct);f(te.$$.fragment,Pa),Pa.forEach(t),Qt.forEach(t),mi=s(pt),ct=o(pt,"SPAN",{"data-svelte-h":!0}),p(ct)!=="svelte-9x6jxy"&&(ct.textContent=zi),pt.forEach(t),Bt=s(e),ne=o(e,"P",{"data-svelte-h":!0}),p(ne)!=="svelte-p89nc2"&&(ne.innerHTML=Hi),Ft=s(e),ie=o(e,"P",{"data-svelte-h":!0}),p(ie)!=="svelte-525bhg"&&(ie.textContent=Li),Ot=s(e),T=o(e,"H2",{class:!0});var ni=c(T);U=o(ni,"A",{id:!0,class:!0,href:!0});var Aa=c(U);qt=o(Aa,"SPAN",{});var Sa=c(qt);f(ae.$$.fragment,Sa),Sa.forEach(t),Aa.forEach(t),vi=s(ni),ut=o(ni,"SPAN",{"data-svelte-h":!0}),p(ut)!=="svelte-1v3qsz2"&&(ut.textContent=ji),ni.forEach(t),Rt=s(e),oe=o(e,"P",{"data-svelte-h":!0}),p(oe)!=="svelte-b9e65e"&&(oe.textContent=Pi),Zt=s(e),le=o(e,"UL",{"data-svelte-h":!0}),p(le)!=="svelte-1jnatgf"&&(le.innerHTML=Ai),Wt=s(e),se=o(e,"P",{"data-svelte-h":!0}),p(se)!=="svelte-1vh20e4"&&(se.innerHTML=Si),Dt=s(e),f(re.$$.fragment,e),Gt=s(e),pe=o(e,"P",{"data-svelte-h":!0}),p(pe)!=="svelte-txsgkq"&&(pe.innerHTML=Ei),Kt=s(e),_=o(e,"H2",{class:!0});var ii=c(_);I=o(ii,"A",{id:!0,class:!0,href:!0});var Ea=c(I);kt=o(Ea,"SPAN",{});var Na=c(kt);f(he.$$.fragment,Na),Na.forEach(t),Ea.forEach(t),gi=s(ii),dt=o(ii,"SPAN",{"data-svelte-h":!0}),p(dt)!=="svelte-9x6jxy"&&(dt.textContent=Ni),ii.forEach(t),Vt=s(e),ce=o(e,"P",{"data-svelte-h":!0}),p(ce)!=="svelte-jca8pk"&&(ce.innerHTML=Ui),Xt=s(e),M=o(e,"H3",{class:!0});var ai=c(M);J=o(ai,"A",{id:!0,class:!0,href:!0});var Ua=c(J);zt=o(Ua,"SPAN",{});var Ia=c(zt);f(ue.$$.fragment,Ia),Ia.forEach(t),Ua.forEach(t),wi=s(ai),ft=o(ai,"SPAN",{"data-svelte-h":!0}),p(ft)!=="svelte-1xgpxgb"&&(ft.innerHTML=Ii),ai.forEach(t),Yt=s(e),de=o(e,"P",{"data-svelte-h":!0}),p(de)!=="svelte-1vonttx"&&(de.innerHTML=Ji),en=s(e),fe=o(e,"UL",{"data-svelte-h":!0}),p(fe)!=="svelte-j3zm40"&&(fe.innerHTML=Qi),tn=s(e),C=o(e,"H3",{class:!0});var oi=c(C);Q=o(oi,"A",{id:!0,class:!0,href:!0});var Ja=c(Q);Ht=o(Ja,"SPAN",{});var Qa=c(Ht);f(me.$$.fragment,Qa),Qa.forEach(t),Ja.forEach(t),bi=s(oi),mt=o(oi,"SPAN",{"data-svelte-h":!0}),p(mt)!=="svelte-1b4hpw1"&&(mt.innerHTML=Bi),oi.forEach(t),nn=s(e),ve=o(e,"P",{"data-svelte-h":!0}),p(ve)!=="svelte-w5smo0"&&(ve.innerHTML=Fi),an=s(e),ge=o(e,"P",{"data-svelte-h":!0}),p(ge)!=="svelte-1hvpx8c"&&(ge.innerHTML=Oi),on=s(e),f(we.$$.fragment,e),ln=s(e),be=o(e,"P",{"data-svelte-h":!0}),p(be)!=="svelte-uc2av9"&&(be.textContent=Ri),sn=s(e),ye=o(e,"UL",{"data-svelte-h":!0}),p(ye)!=="svelte-55l006"&&(ye.innerHTML=Zi),rn=s(e),xe=o(e,"P",{"data-svelte-h":!0}),p(xe)!=="svelte-vbg2s5"&&(xe.innerHTML=Wi),pn=s(e),f($e.$$.fragment,e),hn=s(e),Te=o(e,"P",{"data-svelte-h":!0}),p(Te)!=="svelte-174sqfa"&&(Te.innerHTML=Di),cn=s(e),f(_e.$$.fragment,e),un=s(e),f(B.$$.fragment,e),dn=s(e),q=o(e,"H3",{class:!0});var li=c(q);F=o(li,"A",{id:!0,class:!0,href:!0});var Ba=c(F);Lt=o(Ba,"SPAN",{});var Fa=c(Lt);f(Me.$$.fragment,Fa),Fa.forEach(t),Ba.forEach(t),yi=s(li),vt=o(li,"SPAN",{"data-svelte-h":!0}),p(vt)!=="svelte-toeo3h"&&(vt.textContent=Gi),li.forEach(t),fn=s(e),Ce=o(e,"P",{"data-svelte-h":!0}),p(Ce)!=="svelte-1erfvtl"&&(Ce.innerHTML=Ki),mn=s(e),qe=o(e,"P",{"data-svelte-h":!0}),p(qe)!=="svelte-1m565uj"&&(qe.innerHTML=Vi),vn=s(e),ke=o(e,"P",{"data-svelte-h":!0}),p(ke)!=="svelte-vjpm0g"&&(ke.innerHTML=Xi),gn=s(e),k=o(e,"H3",{class:!0});var si=c(k);O=o(si,"A",{id:!0,class:!0,href:!0});var Oa=c(O);jt=o(Oa,"SPAN",{});var Ra=c(jt);f(ze.$$.fragment,Ra),Ra.forEach(t),Oa.forEach(t),xi=s(si),gt=o(si,"SPAN",{"data-svelte-h":!0}),p(gt)!=="svelte-1k6nr8j"&&(gt.textContent=Yi),si.forEach(t),wn=s(e),He=o(e,"P",{"data-svelte-h":!0}),p(He)!=="svelte-d46ged"&&(He.textContent=ea),bn=s(e),Le=o(e,"UL",{"data-svelte-h":!0}),p(Le)!=="svelte-1h6e562"&&(Le.innerHTML=ta),yn=s(e),z=o(e,"H3",{class:!0});var ri=c(z);R=o(ri,"A",{id:!0,class:!0,href:!0});var Za=c(R);Pt=o(Za,"SPAN",{});var Wa=c(Pt);f(je.$$.fragment,Wa),Wa.forEach(t),Za.forEach(t),$i=s(ri),wt=o(ri,"SPAN",{"data-svelte-h":!0}),p(wt)!=="svelte-1uwjs0j"&&(wt.textContent=na),ri.forEach(t),xn=s(e),Pe=o(e,"P",{"data-svelte-h":!0}),p(Pe)!=="svelte-1fm4s9k"&&(Pe.innerHTML=ia),$n=s(e),Ae=o(e,"P",{"data-svelte-h":!0}),p(Ae)!=="svelte-9f9h6s"&&(Ae.innerHTML=aa),Tn=s(e),Se=o(e,"OL",{"data-svelte-h":!0}),p(Se)!=="svelte-1e9v2jr"&&(Se.innerHTML=oa),_n=s(e),Ee=o(e,"P",{"data-svelte-h":!0}),p(Ee)!=="svelte-bp3yi9"&&(Ee.textContent=la),Mn=s(e),Ne=o(e,"UL",{"data-svelte-h":!0}),p(Ne)!=="svelte-1y2stc2"&&(Ne.innerHTML=sa),Cn=s(e),H=o(e,"H3",{class:!0});var pi=c(H);Z=o(pi,"A",{id:!0,class:!0,href:!0});var Da=c(Z);At=o(Da,"SPAN",{});var Ga=c(At);f(Ue.$$.fragment,Ga),Ga.forEach(t),Da.forEach(t),Ti=s(pi),bt=o(pi,"SPAN",{"data-svelte-h":!0}),p(bt)!=="svelte-1ndt7sp"&&(bt.innerHTML=ra),pi.forEach(t),qn=s(e),Ie=o(e,"P",{"data-svelte-h":!0}),p(Ie)!=="svelte-5xtk1x"&&(Ie.innerHTML=pa),kn=s(e),Je=o(e,"OL",{"data-svelte-h":!0}),p(Je)!=="svelte-ej0tmd"&&(Je.innerHTML=ha),zn=s(e),L=o(e,"H2",{class:!0});var hi=c(L);W=o(hi,"A",{id:!0,class:!0,href:!0});var Ka=c(W);St=o(Ka,"SPAN",{});var Va=c(St);f(Qe.$$.fragment,Va),Va.forEach(t),Ka.forEach(t),_i=s(hi),yt=o(hi,"SPAN",{"data-svelte-h":!0}),p(yt)!=="svelte-26ty2w"&&(yt.textContent=ca),hi.forEach(t),Hn=s(e),Be=o(e,"P",{"data-svelte-h":!0}),p(Be)!=="svelte-3ofdc8"&&(Be.textContent=ua),Ln=s(e),Fe=o(e,"UL",{"data-svelte-h":!0}),p(Fe)!=="svelte-163ivnk"&&(Fe.innerHTML=da),jn=s(e),j=o(e,"H2",{class:!0});var ci=c(j);D=o(ci,"A",{id:!0,class:!0,href:!0});var Xa=c(D);Et=o(Xa,"SPAN",{});var Ya=c(Et);f(Oe.$$.fragment,Ya),Ya.forEach(t),Xa.forEach(t),Mi=s(ci),xt=o(ci,"SPAN",{"data-svelte-h":!0}),p(xt)!=="svelte-11uqman"&&(xt.textContent=fa),ci.forEach(t),Pn=s(e),f(G.$$.fragment,e),An=s(e),Re=o(e,"P",{"data-svelte-h":!0}),p(Re)!=="svelte-h5k7ub"&&(Re.textContent=ma),Sn=s(e),P=o(e,"H4",{class:!0});var ui=c(P);K=o(ui,"A",{id:!0,class:!0,href:!0});var eo=c(K);Nt=o(eo,"SPAN",{});var to=c(Nt);f(Ze.$$.fragment,to),to.forEach(t),eo.forEach(t),Ci=s(ui),$t=o(ui,"SPAN",{"data-svelte-h":!0}),p($t)!=="svelte-ckdoj8"&&($t.textContent=va),ui.forEach(t),En=s(e),We=o(e,"P",{"data-svelte-h":!0}),p(We)!=="svelte-pndq9n"&&(We.innerHTML=ga),Nn=s(e),De=o(e,"OL",{"data-svelte-h":!0}),p(De)!=="svelte-s3ctan"&&(De.innerHTML=wa),Un=s(e),Ge=o(e,"P",{"data-svelte-h":!0}),p(Ge)!=="svelte-73e7m1"&&(Ge.innerHTML=ba),In=s(e),f(Ke.$$.fragment,e),Jn=s(e),V=o(e,"OL",{start:!0,"data-svelte-h":!0}),p(V)!=="svelte-1usbjfc"&&(V.innerHTML=ya),Qn=s(e),A=o(e,"H4",{class:!0});var di=c(A);X=o(di,"A",{id:!0,class:!0,href:!0});var no=c(X);Ut=o(no,"SPAN",{});var io=c(Ut);f(Ve.$$.fragment,io),io.forEach(t),no.forEach(t),qi=s(di),Tt=o(di,"SPAN",{"data-svelte-h":!0}),p(Tt)!=="svelte-ikehbc"&&(Tt.textContent=xa),di.forEach(t),Bn=s(e),Xe=o(e,"P",{"data-svelte-h":!0}),p(Xe)!=="svelte-1vnsbhs"&&(Xe.innerHTML=$a),Fn=s(e),Ye=o(e,"OL",{"data-svelte-h":!0}),p(Ye)!=="svelte-acn83z"&&(Ye.innerHTML=Ta),On=s(e),et=o(e,"P",{"data-svelte-h":!0}),p(et)!=="svelte-vm5l3c"&&(et.textContent=_a),Rn=s(e),tt=o(e,"OL",{"data-svelte-h":!0}),p(tt)!=="svelte-1g2q9e4"&&(tt.innerHTML=Ma),Zn=s(e),nt=o(e,"UL",{"data-svelte-h":!0}),p(nt)!=="svelte-18dzkd8"&&(nt.innerHTML=Ca),Wn=s(e),Y=o(e,"OL",{start:!0,"data-svelte-h":!0}),p(Y)!=="svelte-48nw91"&&(Y.innerHTML=qa),Dn=s(e),it=o(e,"UL",{"data-svelte-h":!0}),p(it)!=="svelte-1gkiele"&&(it.innerHTML=ka),Gn=s(e),at=o(e,"P",{"data-svelte-h":!0}),p(at)!=="svelte-1ugjpds"&&(at.innerHTML=za),Kn=s(e),ot=o(e,"P",{"data-svelte-h":!0}),p(ot)!=="svelte-9ui238"&&(ot.innerHTML=Ha),Vn=s(e),f(lt.$$.fragment,e),Xn=s(e),S=o(e,"H2",{class:!0});var fi=c(S);ee=o(fi,"A",{id:!0,class:!0,href:!0});var ao=c(ee);It=o(ao,"SPAN",{});var oo=c(It);f(st.$$.fragment,oo),oo.forEach(t),ao.forEach(t),ki=s(fi),_t=o(fi,"SPAN",{"data-svelte-h":!0}),p(_t)!=="svelte-4yqj8b"&&(_t.textContent=La),fi.forEach(t),Yn=s(e),rt=o(e,"UL",{"data-svelte-h":!0}),p(rt)!=="svelte-ertv4x"&&(rt.innerHTML=ja),ei=s(e),Jt=o(e,"P",{}),c(Jt).forEach(t),this.h()},h(){r(u,"name","hf:doc:metadata"),r(u,"content",JSON.stringify(go)),r(N,"id","quantization"),r(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(N,"href","#quantization"),r($,"class","relative group"),r(U,"id","theory"),r(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(U,"href","#theory"),r(T,"class","relative group"),r(I,"id","quantization"),r(I,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(I,"href","#quantization"),r(_,"class","relative group"),r(J,"id","quantization-to-float16"),r(J,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(J,"href","#quantization-to-float16"),r(M,"class","relative group"),r(Q,"id","quantization-to-int8"),r(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(Q,"href","#quantization-to-int8"),r(C,"class","relative group"),r(F,"id","symmetric-and-affine-quantization-schemes"),r(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(F,"href","#symmetric-and-affine-quantization-schemes"),r(q,"class","relative group"),r(O,"id","pertensor-and-perchannel-quantization"),r(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(O,"href","#pertensor-and-perchannel-quantization"),r(k,"class","relative group"),r(R,"id","calibration"),r(R,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(R,"href","#calibration"),r(z,"class","relative group"),r(Z,"id","pratical-steps-to-follow-to-quantize-a-model-to-int8"),r(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(Z,"href","#pratical-steps-to-follow-to-quantize-a-model-to-int8"),r(H,"class","relative group"),r(W,"id","supported-tools-to-perform-quantization-in-optimum"),r(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(W,"href","#supported-tools-to-perform-quantization-in-optimum"),r(L,"class","relative group"),r(D,"id","going-further-how-do-machines-represent-numbers"),r(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(D,"href","#going-further-how-do-machines-represent-numbers"),r(j,"class","relative group"),r(K,"id","integer-representation"),r(K,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(K,"href","#integer-representation"),r(P,"class","relative group"),r(V,"start","2"),r(X,"id","real-numbers-representation"),r(X,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(X,"href","#real-numbers-representation"),r(A,"class","relative group"),r(Y,"start","2"),r(ee,"id","references"),r(ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(ee,"href","#references"),r(S,"class","relative group")},m(e,n){h(document.head,u),i(e,x,n),i(e,b,n),i(e,E,n),i(e,$,n),h($,N),h(N,Ct),m(te,Ct,null),h($,mi),h($,ct),i(e,Bt,n),i(e,ne,n),i(e,Ft,n),i(e,ie,n),i(e,Ot,n),i(e,T,n),h(T,U),h(U,qt),m(ae,qt,null),h(T,vi),h(T,ut),i(e,Rt,n),i(e,oe,n),i(e,Zt,n),i(e,le,n),i(e,Wt,n),i(e,se,n),i(e,Dt,n),m(re,e,n),i(e,Gt,n),i(e,pe,n),i(e,Kt,n),i(e,_,n),h(_,I),h(I,kt),m(he,kt,null),h(_,gi),h(_,dt),i(e,Vt,n),i(e,ce,n),i(e,Xt,n),i(e,M,n),h(M,J),h(J,zt),m(ue,zt,null),h(M,wi),h(M,ft),i(e,Yt,n),i(e,de,n),i(e,en,n),i(e,fe,n),i(e,tn,n),i(e,C,n),h(C,Q),h(Q,Ht),m(me,Ht,null),h(C,bi),h(C,mt),i(e,nn,n),i(e,ve,n),i(e,an,n),i(e,ge,n),i(e,on,n),m(we,e,n),i(e,ln,n),i(e,be,n),i(e,sn,n),i(e,ye,n),i(e,rn,n),i(e,xe,n),i(e,pn,n),m($e,e,n),i(e,hn,n),i(e,Te,n),i(e,cn,n),m(_e,e,n),i(e,un,n),m(B,e,n),i(e,dn,n),i(e,q,n),h(q,F),h(F,Lt),m(Me,Lt,null),h(q,yi),h(q,vt),i(e,fn,n),i(e,Ce,n),i(e,mn,n),i(e,qe,n),i(e,vn,n),i(e,ke,n),i(e,gn,n),i(e,k,n),h(k,O),h(O,jt),m(ze,jt,null),h(k,xi),h(k,gt),i(e,wn,n),i(e,He,n),i(e,bn,n),i(e,Le,n),i(e,yn,n),i(e,z,n),h(z,R),h(R,Pt),m(je,Pt,null),h(z,$i),h(z,wt),i(e,xn,n),i(e,Pe,n),i(e,$n,n),i(e,Ae,n),i(e,Tn,n),i(e,Se,n),i(e,_n,n),i(e,Ee,n),i(e,Mn,n),i(e,Ne,n),i(e,Cn,n),i(e,H,n),h(H,Z),h(Z,At),m(Ue,At,null),h(H,Ti),h(H,bt),i(e,qn,n),i(e,Ie,n),i(e,kn,n),i(e,Je,n),i(e,zn,n),i(e,L,n),h(L,W),h(W,St),m(Qe,St,null),h(L,_i),h(L,yt),i(e,Hn,n),i(e,Be,n),i(e,Ln,n),i(e,Fe,n),i(e,jn,n),i(e,j,n),h(j,D),h(D,Et),m(Oe,Et,null),h(j,Mi),h(j,xt),i(e,Pn,n),m(G,e,n),i(e,An,n),i(e,Re,n),i(e,Sn,n),i(e,P,n),h(P,K),h(K,Nt),m(Ze,Nt,null),h(P,Ci),h(P,$t),i(e,En,n),i(e,We,n),i(e,Nn,n),i(e,De,n),i(e,Un,n),i(e,Ge,n),i(e,In,n),m(Ke,e,n),i(e,Jn,n),i(e,V,n),i(e,Qn,n),i(e,A,n),h(A,X),h(X,Ut),m(Ve,Ut,null),h(A,qi),h(A,Tt),i(e,Bn,n),i(e,Xe,n),i(e,Fn,n),i(e,Ye,n),i(e,On,n),i(e,et,n),i(e,Rn,n),i(e,tt,n),i(e,Zn,n),i(e,nt,n),i(e,Wn,n),i(e,Y,n),i(e,Dn,n),i(e,it,n),i(e,Gn,n),i(e,at,n),i(e,Kn,n),i(e,ot,n),i(e,Vn,n),m(lt,e,n),i(e,Xn,n),i(e,S,n),h(S,ee),h(ee,It),m(st,It,null),h(S,ki),h(S,_t),i(e,Yn,n),i(e,rt,n),i(e,ei,n),i(e,Jt,n),ti=!0},p(e,[n]){const pt={};n&2&&(pt.$$scope={dirty:n,ctx:e}),B.$set(pt);const Qt={};n&2&&(Qt.$$scope={dirty:n,ctx:e}),G.$set(Qt)},i(e){ti||(v(te.$$.fragment,e),v(ae.$$.fragment,e),v(re.$$.fragment,e),v(he.$$.fragment,e),v(ue.$$.fragment,e),v(me.$$.fragment,e),v(we.$$.fragment,e),v($e.$$.fragment,e),v(_e.$$.fragment,e),v(B.$$.fragment,e),v(Me.$$.fragment,e),v(ze.$$.fragment,e),v(je.$$.fragment,e),v(Ue.$$.fragment,e),v(Qe.$$.fragment,e),v(Oe.$$.fragment,e),v(G.$$.fragment,e),v(Ze.$$.fragment,e),v(Ke.$$.fragment,e),v(Ve.$$.fragment,e),v(lt.$$.fragment,e),v(st.$$.fragment,e),ti=!0)},o(e){g(te.$$.fragment,e),g(ae.$$.fragment,e),g(re.$$.fragment,e),g(he.$$.fragment,e),g(ue.$$.fragment,e),g(me.$$.fragment,e),g(we.$$.fragment,e),g($e.$$.fragment,e),g(_e.$$.fragment,e),g(B.$$.fragment,e),g(Me.$$.fragment,e),g(ze.$$.fragment,e),g(je.$$.fragment,e),g(Ue.$$.fragment,e),g(Qe.$$.fragment,e),g(Oe.$$.fragment,e),g(G.$$.fragment,e),g(Ze.$$.fragment,e),g(Ke.$$.fragment,e),g(Ve.$$.fragment,e),g(lt.$$.fragment,e),g(st.$$.fragment,e),ti=!1},d(e){e&&(t(x),t(b),t(E),t($),t(Bt),t(ne),t(Ft),t(ie),t(Ot),t(T),t(Rt),t(oe),t(Zt),t(le),t(Wt),t(se),t(Dt),t(Gt),t(pe),t(Kt),t(_),t(Vt),t(ce),t(Xt),t(M),t(Yt),t(de),t(en),t(fe),t(tn),t(C),t(nn),t(ve),t(an),t(ge),t(on),t(ln),t(be),t(sn),t(ye),t(rn),t(xe),t(pn),t(hn),t(Te),t(cn),t(un),t(dn),t(q),t(fn),t(Ce),t(mn),t(qe),t(vn),t(ke),t(gn),t(k),t(wn),t(He),t(bn),t(Le),t(yn),t(z),t(xn),t(Pe),t($n),t(Ae),t(Tn),t(Se),t(_n),t(Ee),t(Mn),t(Ne),t(Cn),t(H),t(qn),t(Ie),t(kn),t(Je),t(zn),t(L),t(Hn),t(Be),t(Ln),t(Fe),t(jn),t(j),t(Pn),t(An),t(Re),t(Sn),t(P),t(En),t(We),t(Nn),t(De),t(Un),t(Ge),t(In),t(Jn),t(V),t(Qn),t(A),t(Bn),t(Xe),t(Fn),t(Ye),t(On),t(et),t(Rn),t(tt),t(Zn),t(nt),t(Wn),t(Y),t(Dn),t(it),t(Gn),t(at),t(Kn),t(ot),t(Vn),t(Xn),t(S),t(Yn),t(rt),t(ei),t(Jt)),t(u),w(te),w(ae),w(re,e),w(he),w(ue),w(me),w(we,e),w($e,e),w(_e,e),w(B,e),w(Me),w(ze),w(je),w(Ue),w(Qe),w(Oe),w(G,e),w(Ze),w(Ke,e),w(Ve),w(lt,e),w(st)}}}const go={local:"quantization",sections:[{local:"theory",title:"Theory"},{local:"quantization",sections:[{local:"quantization-to-float16",title:"Quantization to `float16`"},{local:"quantization-to-int8",title:"Quantization to `int8`"},{local:"symmetric-and-affine-quantization-schemes",title:"Symmetric and affine quantization schemes"},{local:"pertensor-and-perchannel-quantization",title:"Per-tensor and per-channel quantization"},{local:"calibration",title:"Calibration"},{local:"pratical-steps-to-follow-to-quantize-a-model-to-int8",title:"Pratical steps to follow to quantize a model to `int8`"}],title:"Quantization"},{local:"supported-tools-to-perform-quantization-in-optimum",title:"Supported tools to perform quantization in 🤗 Optimum"},{local:"going-further-how-do-machines-represent-numbers",sections:[{local:"integer-representation",title:"Integer representation"},{local:"real-numbers-representation",title:"Real numbers representation"}],title:"Going further: How do machines represent numbers?"},{local:"references",title:"References"}],title:"Quantization"};function wo(ht){return po(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class _o extends ho{constructor(u){super(),co(this,u,wo,vo,ro,{})}}export{_o as component};
